/*
 * @(#)init.c	1.34 Feb.23,1996
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * Copyright (C) yamasita@omronsoft.co.jp
 */

#ifdef WINDOWS
#	include <windows.h>
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#ifdef	SIGWINCH
#	include	<sys/ioctl.h>
#endif
#ifdef	SVR4
#	include	<sys/termios.h>
#endif

#ifdef MSDOS
#	include	<stdlib.h>
#	include	<string.h>
#	if defined(WATTCP)
#		include <tcp.h>
#	endif
#	if ! defined(HUMAN68K) && ! defined(GNUDOS) && ! defined(__TURBOC__)
#		include	<direct.h>
#	endif
#	ifdef __TURBOC__
#		include <dir.h>
#	endif
#	ifdef OS2
#		define INCL_DOSFILEMGR     /* for DosQCurDisk and DosSelectDisk */
#		define INCL_VIO            /* for VioGetMode */
#		include <os2.h>
#	endif
#	ifdef PCNFS
#		include "pcnfs.h"
#	endif
#	ifdef WINSOCK
#		include <winsock.h>
#	endif
#endif /* MSDOS */

#ifdef	UNIX
#	ifdef NECODT
#		include	<sys/stream.h>
#		include	<sys/ptem.h>
#	endif	/* NECODT */
#	if defined(sony_news) || defined(__sony_news)
#		if defined(USG)
#			include	<sys/termios.h>
#			include	<sys/utsname.h>
#		endif
#		include	<locale.h>
#	endif
#	ifdef nec_ews
#		include <sys/termios.h>
#	endif
#	include	<pwd.h>
#	ifdef	HAS_STRING_H
#		include	<string.h>
#	endif
#	ifdef	HAS_STDLIB_H
#		include	<stdlib.h>
#	endif
#	ifdef	HAS_MALLOC_H
#		include	<malloc.h>
#	endif
#	ifdef	HAS_SYS_IOCTL_H
#		include	<sys/ioctl.h>
#	endif
#	ifdef	HAS_UNISTD_H
#		include	<unistd.h>
#	endif
#	ifdef	HAS_SYS_TERMIO_H
#		ifndef sparc
#			include	<sys/termio.h>
#		endif
#	endif
#	ifdef	uniosu
char *getenv();
#	endif
#endif /* UNIX */

#include	"nntp.h"
#include	"version.h"
#include	"gn.h"
#include	"config.h"

extern void init_gn_1();
extern int init_gn_2();
extern int read_option();
extern char *kb_input();
extern char *expand_filename();
extern void mc_puts(),mc_printf();
extern void hit_return();
extern void kanji_convert();
extern void memory_error();
extern int lock_gn();
extern int read_gnrc(),read_env();
extern int check_regexp_group();

#if defined(WINDOWS)
extern int mc_MessageBox();
#endif	/* WINDOWS */

char *gn_version = VERSION;
char *gn_date = DATE;


newsgroup_t *newsrc;		/* ˥塼롼ץꥹ */
last_art_t last_art;		/* Ǹɤ */
void (*redraw_func)();

gn_t gn;			/* ޥ */
int internal_kanji_code;	/* gn δ */
int change;			/* newsrc ե饰 */
int make_article_tmpfile = ON;	/* ڡ˥ƥݥեϤ */
int disp_mode;			/* åɽ */
char *ngdir;

/* for gnspool */
int gnspooljobs = 0;		/* BIT_EXPIRE,BIT_POST,BIT_MAIL,BIT_GET */
int init_smtp_server = 0;

#if defined(WINDOWS)
int	xsiz, ysiz, wwidth, wheight, xpos, ypos;
char *display_buf = 0;

HANDLE hInst;			/* ߤΥ󥹥 */
HWND hWnd;			/* ᥤ󥦥ɥΥϥɥ */
HCURSOR hHourGlass;		/* ץ */
#endif	/* WINDOWS */

#ifdef	SIGWINCH
static void resize_window();
#endif	/* SIGWINCH */

#ifdef	SIGCONT
static void foreground();
#endif	/* SIGCONT */


static char *mail_lang = 0;
static char *process_lang = 0;
static char *file_lang = 0;
static char *display_lang = 0;
static char *gnspool_lang = 0;
static char *unsubscribe_string = 0;
static char *subscribe_string = 0;

struct env_t {
  char *str;
  char **value;
};
static struct env_t env_table[] = {
  /* ɥᥤ */
  { GNRC_DOMAINNAME,	&gn.domainname },	/* ɥᥤ̾ */
  { GNRC_ORGANIZATION,	&gn.organization },	/* ȿ̾ */

  /* ˥塼ƥ */
  { GNRC_NNTPSERVER,	&gn.nntpserver },/* ˥塼 */
  { GNRC_POSTPROC,	&gn.postproc },	/* -l ݥȤΥץ */
  { GNRC_NEWSLIB,	&gn.newslib },	/* /usr/lib/news */
  { GNRC_NEWSSPOOL,	&gn.newsspool },/* /usr/spool/news */

  /* ᥤ륷ƥ */
  { GNRC_SMTPSERVER,	&gn.smtpserver },	/* smtp,pop3|ftp  */
  { GNRC_MAIL_LANG,	&mail_lang },		/* ᥤδ */
  { GNRC_MAILER,	&gn.mailer },	/* ᥤ */

  /* ۥ */
  { GNRC_HOST,		&gn.hostname },	/* ۥ̾ */
  { GNRC_PROCESS_LANG,	&process_lang },/* ڡ㡿ǥδ */
  { GNRC_FILE_LANG,	&file_lang },	/* եδ */
  { GNRC_DISPLAY_LANG,	&display_lang },/* ǥץ쥤δ */
  { GNRC_PAGER,		&gn.pager },	/* ڡ */
  { GNRC_EDITOR,	&gn.editor },	/* ǥ */
  { GNRC_WIN_EDITOR,	&gn.win_editor },	/* Windows λΥǥ */

  /* 桼 */
  { GNRC_NAME,		&gn.fullname },		/* Full Name */
#ifdef	USG
  { GNRC_USER,		&gn.usrname },
  { GNRC_LOGNAME,	&gn.usrname },
#else	/* USG */
  { GNRC_LOGNAME,	&gn.usrname },
  { GNRC_USER,		&gn.usrname },
#endif	/* USG */
  { GNRC_PASSWD,	&gn.passwd },

  /* directory / file */
  { GNRC_HOME,		&gn.home },	/* $HOME */
  { GNRC_NEWSRC,	&gn.rcfile },		/* .newsrc */
  { GNRC_SAVEDIR,	&gn.savedir },	/* ¸ǥ쥯ȥ */
  { GNRC_SIGNATURE,	&gn.signature },	/* .signature */
  { GNRC_AUTHOR_COPY,	&gn.author_copy },	/* author_copy */
  { GNRC_TMPDIR,	&gn.tmpdir },	/* ƥݥǥ쥯ȥ */
  { GNRC_TMP,		&gn.tmpdir },	/* ƥݥǥ쥯ȥ */
  { GNRC_TEMP,		&gn.tmpdir },	/* ƥݥǥ쥯ȥ */
  { GNRC_JNAMESFILE,	&gn.jnames_file },

  /* read */
  { GNRC_IGNORE,	&unsubscribe_string },	/* ̵뤹 newsgroup  */
  { GNRC_UNSUBSCRIBE,	&unsubscribe_string },	/* ̵뤹 newsgroup  */
  { GNRC_SUBSCRIBE,	&subscribe_string },	/* ɤ newsgroup  */

  /* other */
  { GNRC_GNSPOOL_LANG,	&gnspool_lang },	/* gnspool 륹סδ */


  { 0,0 }
};
struct lang_t {
  char *str;
  int value;
};
static struct lang_t lang_table[] = {
  {"JIS",		JIS},
  {"C",			JIS},
  {"ja_JP.jis7",	JIS},
  {"ja_JP.jis8",	JIS},
  {"ja_JP.pjis",	JIS},
  {"ja_JP.jis",		JIS},
  {"wr_WR.ct",		JIS},
  {"wr_WR.junet",	JIS},
  
  {"EUC",		EUC},
  {"UJIS",		EUC},
  {"ja_JP.ujis",	EUC},
  {"ja_JP.euc",		EUC},
  {"ja_JP.EUC",		EUC},
  {"ja_JP.eucJP",	EUC},
  {"ja",		EUC},
  {"japanese",		EUC},
  
  {"SJIS",		SJIS},
  {"ja_JP.sjis",	SJIS},
  {"ja_JP.SJIS",	SJIS},
  {"ja_JP.mscode",	SJIS},
  {0,0 }
};
struct gnrc_t {
  char *str;
  int *value;
};
static struct gnrc_t gnrc_table[] = {
  /* ɥᥤ */
  { GNRC_GENERICFROM,	&gn.genericfrom },

  /* ˥塼ƥ */
  { GNRC_MODE_READER,	&gn.mode_reader },
  { GNRC_NNTP_AUTH,	&gn.nntp_auth },
  { GNRC_LOCAL_SPOOL,	&gn.local_spool },
  { GNRC_USE_HISTORY,	&gn.use_history },	/* history Ѥ */
  { GNRC_DOS_NEWFS,	&gn.dos_newfs },/* HPFS,NTFS ʤɤ spool  */

  /* ۥ */
  { GNRC_LINES,		&gn.lines },
  { GNRC_WIN_LINES,	&gn.win_lines },
  { GNRC_COLUMNS,	&gn.columns },
  { GNRC_WIN_COLUMNS,	&gn.win_columns },
  { GNRC_RETURN_AFTER_PAGER,	&gn.return_after_pager },
  { GNRC_WIN_PAGER_FLAG,&gn.win_pager_flag },	/* ǽڡǻߤޤ */
  { GNRC_USE_SPACE,	&gn.use_space },	/* ڡɤ߿ʤ */
  { GNRC_POWER_SAVE,	&gn.power_save },	/* ǥؤΥ */

  /* directory / file */
  { GNRC_GNUS_FORMAT,	&gn.gnus_format },
  { GNRC_NG_SORT,	&gn.ng_sort },		/* sort new newsgroup */

  /* read */
  { GNRC_ARTICLE_LIMIT,	&gn.article_limit },
  { GNRC_ARTICLE_LEAVE,	&gn.article_leave },
  { GNRC_SELECT_LIMIT,	&gn.select_limit },
  { GNRC_DISP_RE,	&gn.disp_re },	/* եλ Re: ɽ */
  { GNRC_CLS,		&gn.cls },		/* ̥ꥢ */
  { GNRC_DESCRIPTION,	&gn.description },
  { GNRC_KILL_CANCEL,	&gn.kill_control },	/* upper compatible */
  { GNRC_KILL_CONTROL,	&gn.kill_control },
  { GNRC_AUTOLIST,	&gn.autolist },
  { GNRC_SHOW_INDENT,	&gn.show_indent },	/* ⡼˻ɽ */
  { GNRC_SHOW_TRUNCATE,	&gn.show_truncate },	/* ޤʤɽ */
  { GNRC_MIME_HEAD,	&gn.mime_head },	/* إå MIME б */
  { GNRC_GMT2JST,	&gn.gmt2jst },		/* Date: إå JST ɽ */

  /* post */
  { GNRC_NSUBJECT,	&gn.nsubject },	/* ܸ쥵֥Ȼ */
  { GNRC_RN_LIKE,	&gn.rn_like },	/* rn 饤ʰѥ */
  { GNRC_CC2ME,		&gn.cc2me },	/* ץ饤᡼ʬˤ Cc/Bcc */
  /* other */
  { GNRC_WITH_GNSPOOL,	&gn.with_gnspool },/* gnspool ȹ礻ƻѤ */

  /* for gnspool only */
  { GNRC_FAST_CONNECT,	&gn.fast_connect },	/* active ʤ */
  { GNRC_REMOVE_CANCELED,	&gn.remove_canceled },	/* 󥻥뤵줿ä */

  { 0,0 }
};

#ifdef	WINDOWS
BOOL
InitApplication(hInstance)
HANDLE hInstance;
{
  long CALLBACK __export MainWndProc(HWND, UINT, WPARAM, LPARAM);
  
  WNDCLASS  wc;
  
  /* wc.style = NULL; */
  wc.style = CS_DBLCLKS;
  wc.lpfnWndProc = MainWndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  
  if ( prog == GN ) {
    wc.hIcon = LoadIcon(hInstance, "IDI_GN");
    wc.lpszClassName = "GnWClass";
    wc.lpszMenuName =  "IDR_GNMENU";
  } else {
    wc.hIcon = LoadIcon(hInstance, "IDI_GNSPOOL");
    wc.lpszClassName = "GnspoolWClass";
    wc.lpszMenuName =  "IDR_GNSPOOLMENU";
  }
  return (RegisterClass(&wc));
}

BOOL
InitInstance(hInstance, nCmdShow)
HANDLE hInstance;
int nCmdShow;
{
  HDC             hdc;
  TEXTMETRIC      textmetric;
  
  hHourGlass = LoadCursor(NULL, IDC_WAIT);  	/* ץ */
  
  hInst = hInstance;
  
  /* ᥤ󥦥ɥ */
  
  hWnd = CreateWindow(( prog == GN ) ? "GnWClass" : "GnspoolWClass",
		      ( prog == GN ) ? "gn" : "gnspool", /* title bar */
		      WS_OVERLAPPEDWINDOW, /* window style */
		      CW_USEDEFAULT, /* x */
		      CW_USEDEFAULT, /* y */
		      CW_USEDEFAULT, /* w */
		      CW_USEDEFAULT, /* h */
		      NULL,
		      NULL,
		      hInstance,
		      NULL);
  
  if (!hWnd)	/* ɥǤʤä */
    return(FALSE);
  
  hdc = GetDC(hWnd);
  if (!hdc)
    return(FALSE);
  GetTextMetrics(hdc, &textmetric);
  xsiz = textmetric.tmAveCharWidth;
  ysiz = textmetric.tmHeight;
  
  return(TRUE);
}
void
create_arg(arg)
char *arg;
{
  int	argc;
  char **argv,**argvp;
  register char *pt;
  
  /* argv ο */
  pt = arg;
  argc = 1;
  while (1) {
    while( *pt == ' ' || *pt == TAB )
      pt++;
    if ( *pt == 0 )
      break;
    argc++;
    while( *pt != ' ' && *pt != TAB && *pt != 0 )
      pt++;
    if ( *pt == 0 )
      break;
  }
  
  if ( (argv = malloc(sizeof(char *) * (argc+1))) == NULL ){
    memory_error();
    return;
  }
  argv[0] = ( prog == GN ) ? "gn" : "gnspool";
  argvp = &argv[1];
  
  pt = arg;
  while (1) {
    while( *pt == ' ' || *pt == TAB )
      pt++;
    if ( *pt == 0 )
      break;
    *argvp++ = pt;
    while( *pt != ' ' && *pt != TAB && *pt != 0 )
      pt++;
    if ( *pt == 0 )
      break;
    *pt++ = 0;
  }
  *argvp = 0;
  
  PostMessage(hWnd, WM_START,(WPARAM)argc, (LPARAM)argv);
}

#endif	/* WINDOWS */
int
gn_init(argc,argv)
int argc;
char *argv[];
{
#ifdef	DOSFS
  extern int GetDisk(),SetDisk();
#endif
#ifdef	MSDOS
  extern int auth();
#	if defined (OS2) || ( defined (DOSV) && !defined(GNUDOS) )
  extern int GetLines(),GetColumns();
#	endif	/* OS2 || DOSV */
#	if defined(INETBIOS) || defined(PATHWAY) || defined(LWP)
#		if ! defined(NO_NET)
  extern int find_inet();
#		endif	/* ! NO_NET */
#	endif
#endif /* MSDOS */

#ifdef	WINDOWS
  RECT	lprct,lprcw;
#endif
  register char *env,*gnrc;
  char resp[NNTP_STRLEN*2+1];
  struct stat stat_buf;
  int check_only = CONT;
  register struct lang_t *lang_tp;
  char *pt;
  int disk = -1;
  
#if defined(WINSOCK)
  WORD wVersionRequested;
  WSADATA wsaData;
#endif	/* WINSOCK */
  
#ifndef	MSDOS
  char *sp;
  char full_name[MAXNAME];
  char host_name[MAXHOSTNAME+1];
  struct	passwd *pw,*getpwnam();
#endif /* DOS */
#if defined(sony_news) || defined(__sony_news)
  char *lang = setlocale(LC_CTYPE, "");
  int ttype;
#endif
  
  /* ѿν */
  newsrc = 0;
  change = 0;
  redraw_func = (void (*)())NULL;
  internal_kanji_code = ((unsigned char *)"")[0] == 0x82 ? SJIS : EUC;
  disp_mode = THREADED;
  ngdir = 0;
  

  /* struct gn *******************************/
  init_gn_1();

#if defined(sony_news) || defined(__sony_news)
  gn.process_kanji_code = JIS;
  gn.file_kanji_code = JIS;
  gn.display_kanji_code = JIS;
  for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
    if (strcmp(lang_tp->str,lang) == 0 ) {
      gn.process_kanji_code = lang_tp->value;
      gn.file_kanji_code = lang_tp->value;
      gn.display_kanji_code = lang_tp->value;
      break;
    }
  }
  if (ioctl(0, TIOCKGET, &ttype) != 0 ||
      ((ttype & KM_TTYPE) == KM_ASCII)) {
    gn.display_kanji_code = JIS;
  }
#endif /* defined(sony_news) || defined(__sony_news) */

  last_art.tmp_file[0] = 0;
  last_art.newsgroups[0] = 0;
  last_art.from[0] = 0;
  last_art.date[0] = 0;
  last_art.references[0] = 0;
  last_art.xref[0] = 0;
  last_art.art_numb = 0;
  
  if ( (env = getenv("HOME")) == 0 ) {
    if ( (gn.home = malloc(strlen(SLASH_STR)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.home,SLASH_STR);
  } else {
    if ( (gn.home = malloc(strlen(env)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.home,env);
  }
  
#ifdef	DOSFS
  while ( (pt = strchr(gn.home,'/')) != NULL )
    *pt = SLASH_CHAR;
#endif
  
  /* ̹Կμ */
#ifdef	SIGWINCH
  signal(SIGWINCH, resize_window);
  resize_window();
#endif

#if defined (OS2)
  gn.lines = GetLines();
  gn.columns = GetColumns();
#endif

#if defined (DOSV) && !defined(GNUDOS)
  gn.lines = GetLines();
  gn.columns = GetColumns() - 1;		    /* for ansi.sys */
#endif	/* DOSV && !GNUDOS */

#ifdef	WINDOWS
  GetClientRect(hWnd,&lprcw);
  gn.lines = lprcw.bottom / ysiz;
  gn.columns = lprcw.right / xsiz;
  if ( (display_buf = malloc(gn.lines*gn.columns)) == NULL ) {
    memory_error();
    return(QUIT);
  }
  memset(display_buf,' ',gn.lines*gn.columns);
#endif /* WINDOWS */
  /**************************************************************************/
  
  /* $HOME/.gnrc β */
  if ( (gnrc = expand_filename(GNRC,gn.home)) == 0 ) {
#if ! defined(WINDOWS)
    mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",GNRC);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ե̾Ÿ˼Ԥޤ",GNRC,MB_OK);
#endif	/* WINDOWS */
    return(QUIT);
  }
  
  if ( read_gnrc(gnrc) == ERROR)
    return(QUIT);
  
  /* Ķѿβ */
  if ( read_env() == ERROR )
    return(QUIT);
  
  /* ưץβ */
  if ( read_option(argc,argv,&check_only) == ERROR )
    return(QUIT);

  /* ˥塼ФꤵƤʤ */
  if ( gn.nntpserver == 0 ) {
    if ( (gn.nntpserver = malloc(strlen(DEFAULT_NNTPSERVER)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.nntpserver,DEFAULT_NNTPSERVER);
  }
  while (1) {
    if ( strlen(gn.nntpserver) != 0 && strcmp(gn.nntpserver,"your-nntpserver") != 0 )
      break;
    if ( (pt = kb_input("˥塼ФΥۥ̾ϤƲ")) == NULL)
      return(QUIT);
    if ( strlen(pt) == 0 )
      continue;
    free(gn.nntpserver);
    if ( (gn.nntpserver = malloc(strlen(pt)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.nntpserver,pt);
    break;
  }
  
  /* .gnrc-NNTPSERVER */
  if ( (env = expand_filename(GNRC,gn.home)) == 0 ) {
#if ! defined(WINDOWS)
    mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",GNRC);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ե̾Ÿ˼Ԥޤ",GNRC,MB_OK);
#endif	/* WINDOWS */
    return(QUIT);
  }
  
  strcpy(resp,env);
  strcat(resp,"_");
  strcat(resp,gn.nntpserver);
  if ( stat(resp,&stat_buf) == 0 ) {
    if ( read_gnrc(resp) == ERROR )
      return(QUIT);
  } else {
    strcpy(resp,env);
    strcat(resp,"-");
    strcat(resp,gn.nntpserver);
    if ( stat(resp,&stat_buf) == 0 ) {
      if ( read_gnrc(resp) == ERROR )
	return(QUIT);
    } else {
      strcpy(resp,env);
      strcat(resp,".");
      strcat(resp,gn.nntpserver);
      if ( stat(resp,&stat_buf) == 0 ) {
	if ( read_gnrc(resp) == ERROR )
	  return(QUIT);
      }
    }
  }

  /************************************************************************/

  if ( init_gn_2() == QUIT )
    return(QUIT);

  /* ɥᥤ */

  /* domainname ϥޥƤʤФʤʤ */
  if (strlen(gn.domainname) <= 0 ||
      strcmp(gn.domainname,"your.domain.name") == 0 ) {
#ifndef	WINDOWS
    mc_puts("ɥᥤ̾ꤵƤޤ \n");
    exit(1);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ɥᥤ̾ꤵƤޤ ","",MB_OK);
    return(QUIT);
#endif	/* WINDOWS */
  }

  /* organization ϥޥƤʤФʤʤ */
  if (strlen(gn.organization) <= 0 ||
      strcmp(gn.organization,"your organization") == 0 ) {
#ifndef	WINDOWS
    mc_puts("ȿ̾ꤵƤޤ \n");
    exit(1);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ȿ̾ꤵƤޤ ","",MB_OK);
    return(QUIT);
#endif	/* WINDOWS */
  }

  /* ˥塼ƥ */

  if ( (gn.newslib = expand_filename(gn.newslib,gn.home)) == 0 ) {
#if ! defined(WINDOWS)
    mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",gn.newslib);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ե̾Ÿ˼Ԥޤ",gn.newslib,MB_OK);
#endif	/* WINDOWS */
    return(QUIT);
  }
  
  if ( (gn.newsspool = expand_filename(gn.newsspool,gn.home)) == 0 ) {
#if ! defined(WINDOWS)
    mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",gn.newsspool);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ե̾Ÿ˼Ԥޤ",gn.newsspool,MB_OK);
#endif	/* WINDOWS */
    return(QUIT);
  }
  

  /* ۥ */

  /*
   * ۥ̾
   */
#ifdef	MSDOS
  if ( gn.genericfrom == 0 && gn.hostname == 0 ) {
#ifndef	WINDOWS
    mc_puts("HOST ˡУäΥۥ̾ꤷƲ\n");
    exit(1);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"HOST ˡУäΥۥ̾ꤷƲ","",MB_OK);
    return(QUIT);
#endif	/* WINDOWS */
  }
  
#else	/* MSDOS */
  if ( gn.hostname == 0 ) {
#if ( defined(sony_news) || defined(__sony_news) ) && defined(USG)
    struct utsname name;
    uname(&name);
    if ( (gn.hostname = malloc(strlen(name.nodename)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.hostname,name.nodename);
#else	/* sony news USG */
    /* hostname  domainname ĤƤϡ */
    if ( gethostname(host_name,MAXHOSTNAME) != 0 ) {
      mc_puts("\nۥ̾ǤޤǤ\n\007");
      exit(1);
    }
    if ( (gn.hostname = malloc(strlen(host_name)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.hostname,host_name);
#endif	/* sony news USG */
  }
#endif	/* MSDOS */

  /* 桼 */

  /*
   * login name
   */
#ifdef	MSDOS
  if ( gn.usrname == 0 ) {
#ifndef	WINDOWS
    mc_puts("USER ˡ桼̾ꤷƲ\n");
    exit(1);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"USER ˡ桼̾ꤷƲ","",MB_OK);
    return(QUIT);
#endif	/* WINDOWS */
  }
#else	/* MSDOS */
  if ( gn.usrname == 0 ) {
    mc_puts("\n桼̾ǤޤǤ\n\007");
    exit(1);
  }
  if ( (pw = getpwnam(gn.usrname)) == NULL ){
    mc_puts("\nѥɥȥ꤬ǤޤǤ\n\007");
    exit(1);
  }
  if ( (pt = getenv("LOGINNAME")) != 0 )
    gn.usrname = pt;
#endif	/* MSDOS */

  /*
   * Full Name
   */
#ifdef	MSDOS
  if ( gn.fullname == 0 ) {
#ifndef	WINDOWS
    mc_puts("NAME ˡ̾ꤷƲ\n");
    exit(1);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"NAME ˡ̾ꤷƲ","",MB_OK);
    return(QUIT);
#endif	/* WINDOWS */
  }
#else	/* MSDOS */
  if ( gn.fullname == 0 ) {
    pt = (char *)pw->pw_gecos;
    sp = full_name;
    while (*pt != '\0' && *pt != ',' && *pt != ';' && *pt != '%') {
      if (*pt == '&') {
	strcpy(sp, gn.usrname);
	if ( 'a' <= *sp && *sp <= 'z' )
	  *sp = *sp - 'a' + 'A';
	while (*sp != '\0')
	  sp++;
	pt++;
      } else {
	*sp++ = *pt++;
      }
    }
    *sp = 0;
    if ( (gn.fullname = malloc(strlen(full_name)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.fullname,full_name);
  }
#endif	/* MSDOS */

  /* directory / file */

  /* .newsrc_NNTPSERVER */
  if ( (env = expand_filename(gn.rcfile,gn.home)) == 0 ) {
#if ! defined(WINDOWS)
    mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",gn.rcfile);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ե̾Ÿ˼Ԥޤ",gn.rcfile,MB_OK);
#endif	/* WINDOWS */
    return(QUIT);
  }
  strcpy(resp,env);
  strcat(resp,"_");
  strcat(resp,gn.nntpserver);
  if ( stat(resp,&stat_buf) == 0 ) {
    if ( (gn.rcfile = malloc(strlen(resp)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.rcfile,resp);
  } else {
    strcpy(resp,env);
    strcat(resp,"-");
    strcat(resp,gn.nntpserver);
    if ( stat(resp,&stat_buf) == 0 ) {
      if ( (gn.rcfile = malloc(strlen(resp)+1)) == NULL ) {
	memory_error();
	return(QUIT);
      }
      strcpy(gn.rcfile,resp);
    } else {
      strcpy(resp,env);
      strcat(resp,".");
      strcat(resp,gn.nntpserver);
      if ( stat(resp,&stat_buf) == 0 ) {
	if ( (gn.rcfile = malloc(strlen(resp)+1)) == NULL ) {
	  memory_error();
	  return(QUIT);
	}
	strcpy(gn.rcfile,resp);
      } else {
	gn.rcfile = env;
      }
    }
  }

#ifdef	DOSFS
  while ( (pt = strchr(gn.savedir,'/')) != NULL )
    *pt = SLASH_CHAR;				    /* / -> \ */
#endif	/* MSDOS */
  /* savedir Ÿ */
  if ( (pt = expand_filename(gn.savedir,gn.home)) == 0 ) {
#if ! defined(WINDOWS)
    mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",gn.savedir);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ե̾Ÿ˼Ԥޤ",gn.savedir,MB_OK);
#endif	/* WINDOWS */
    return(QUIT);
  }
  free(gn.savedir);
  gn.savedir = pt;
  
  /* savedir ϥǥ쥯ȥǤʤФʤʤ */
  if ( stat(gn.savedir,&stat_buf) == 0 ) {
    if ( (stat_buf.st_mode & S_IFMT) != S_IFDIR ) {	/* S_IFLNK  ? */
#ifndef	WINDOWS
      mc_puts("¸ǥ쥯ȥȤƥǥ쥯ȥʳꤵƤޤ\n");
      /* 㤡ǥ쥯ȥϤ¥ */
      exit(1);
#else	/* WINDOWS */
      mc_MessageBox(hWnd,"¸ǥ쥯ȥȤƥǥ쥯ȥʳꤵƤޤ","",MB_OK);
      return(QUIT);
#endif	/* WINDOWS */
    }
  }
  /* savedir κǸ / ǽ褦ˤ */
  if ( gn.savedir[strlen(gn.savedir)-1] != SLASH_CHAR ) {
    if ( (pt = malloc(strlen(gn.savedir)+2)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(pt,gn.savedir);
    strcat(pt,SLASH_STR);
    free(gn.savedir);
    gn.savedir = pt;
  }

  if ( (gn.signature = expand_filename(gn.signature,gn.home)) == 0 ){
#if ! defined(WINDOWS)
    mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",gn.signature);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ե̾Ÿ˼Ԥޤ",gn.signature,MB_OK);
#endif	/* WINDOWS */
    return(QUIT);
  }

  if ( (gn.author_copy = expand_filename(gn.author_copy,gn.home)) == 0 ) {
#if ! defined(WINDOWS)
    mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",gn.author_copy);
#else	/* WINDOWS */
    mc_MessageBox(hWnd,"ե̾Ÿ˼Ԥޤ",gn.author_copy,MB_OK);
#endif	/* WINDOWS */
    return(QUIT);
  }
  
#ifdef	DOSFS
  while ( (pt = strchr(gn.tmpdir,'/')) != NULL )
    *pt = SLASH_CHAR;

  if ( (pt = strchr(gn.tmpdir, ':')) != NULL){
    /* tmpdir ˥ǥ񤫤Ƥ */
    pt++;
    disk = GetDisk();
    if (SetDisk(toupper(gn.tmpdir[0])-'A')){
#ifndef	WINDOWS
      mc_puts("ꤵ줿ƥݥǥϻȤޤ \n");
      return(QUIT);
#else	/* WINDOWS */
      mc_MessageBox(hWnd,"ꤵ줿ƥݥǥϻȤޤ ","",MB_OK);
      return(QUIT);
#endif	/* WINDOWS */
    }
    SetDisk(disk);
  }
#endif	/* DOSFS */

  /* tmpdir ϥǥ쥯ȥǤʤФʤʤ */
  if (disk == -1)
    pt = gn.tmpdir;
  if (strcmp(pt, SLASH_STR) != 0 && strcmp(pt, "") !=0){
    /* tmpdir='/' or tmpdir='\0' ϥåʤ - ȤMS-DOS */
    if ( stat(gn.tmpdir,&stat_buf) != 0 ) {
      if ( MKDIR(gn.tmpdir) != 0 ) {	/* boooom */
#ifndef	WINDOWS
	mc_printf("ƥݥǥ쥯ȥȤƻꤵƤ %s 뤳ȤǤޤ \n",gn.tmpdir);
	perror(gn.tmpdir);
	exit(1);
#else	/* WINDOWS */
	mc_MessageBox(hWnd,"ƥݥǥ쥯ȥ뤳ȤǤޤ ",
		      gn.tmpdir,MB_OK);
	return(QUIT);
#endif	/* WINDOWS */
      } else {
	mc_printf("ƥݥǥ쥯ȥȤƻꤵƤ %s ¸ߤʤäᡢޤ\n",gn.tmpdir);
      }
    } else {
      if ( (stat_buf.st_mode & S_IFMT) != S_IFDIR ) {	/* S_IFLNK  ? */
#ifndef	WINDOWS
	mc_puts("ƥݥǥ쥯ȥȤƥǥ쥯ȥʳꤵƤޤ\n");
	/* 㤡ǥ쥯ȥϤ¥ */
	exit(1);
#else	/* WINDOWS */
	mc_MessageBox(hWnd,"ƥݥǥ쥯ȥȤƥǥ쥯ȥʳꤵƤޤ",
		      "",MB_OK);
	return(QUIT);
#endif	/* WINDOWS */
      }
    }
  }
  /* tmpdir κǸ / ǽ褦ˤ */
  if ( gn.tmpdir[strlen(gn.tmpdir)-1] != SLASH_CHAR ) {
    if ( (pt = malloc(strlen(gn.tmpdir)+2)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(pt,gn.tmpdir);
    strcat(pt,SLASH_STR);
    free(gn.tmpdir);
    gn.tmpdir = pt;
  }
  
  /************************************************************************/

#ifdef	WINDOWS
  if ( gn.win_lines != -1 )
    gn.lines = gn.win_lines;

  if ( gn.win_columns != -1 )
    gn.columns = gn.win_columns;

  if ( gn.win_editor != NULL ) {
    free(gn.editor);
    gn.editor = gn.win_editor;
  }
#endif	/* WINDOWS */
  
  /* ̵뤹˥塼롼 */
  if ( unsubscribe_string != 0 ) {
    if ( check_regexp_group(unsubscribe_string,&gn.unsubscribe_groups) == ERROR )
      return(QUIT);
    if ( subscribe_string != 0 ) {
      free(subscribe_string);
      subscribe_string = 0;
    }
  }
  /* ɤ˥塼롼 */
  if ( subscribe_string != 0 ) {
    if ( check_regexp_group(subscribe_string,&gn.subscribe_groups) == ERROR )
      return(QUIT);
  }
  
  /*  */
  if ( mail_lang != 0 ) {
    for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
      if (strcmp(lang_tp->str,mail_lang) == 0 ) {
	gn.mail_kanji_code = lang_tp->value;
	break;
      }
    }
  }
  if ( process_lang != 0 ) {
    for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
      if (strcmp(lang_tp->str,process_lang) == 0 ) {
	gn.process_kanji_code = lang_tp->value;
	break;
      }
    }
  }
  if ( file_lang != 0 ) {
    for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
      if (strcmp(lang_tp->str,file_lang) == 0 ) {
	gn.file_kanji_code = lang_tp->value;
	break;
      }
    }
  }
  if ( display_lang != 0 ) {
    for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
      if (strcmp(lang_tp->str,display_lang) == 0 ) {
	gn.display_kanji_code = lang_tp->value;
	break;
      }
    }
  }
  
  if ( gnspool_lang != 0 ) {
    for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
      if (strcmp(lang_tp->str,gnspool_lang) == 0 ) {
	gn.gnspool_kanji_code = lang_tp->value;
	break;
      }
    }
  }
#ifndef MSDOS
  /* åեΥå */
  if ( lock_gn(gn.nntpserver) != 0 ) {	/* lock file OK ? */
    mc_puts("Ǥ gn ưƤޤ\n");
    exit(1);
  }
#endif
  
  
#ifdef	SIGCONT
  signal(SIGCONT, foreground);
#endif
  
#if ! defined(NO_NET)
#if defined(WINSOCK)
  if (gn.local_spool == OFF) {	/* ͥåȥ⡼ */
    wVersionRequested = 0x0101;
    if ( WSAStartup(wVersionRequested, &wsaData) != 0) {
#ifndef	WINDOWS
      mc_puts("winsock ߤĤޤ \n");
      exit(1);
#else	/* WINDOWS */
      mc_MessageBox(hWnd,"winsock ߤĤޤ ","",MB_OK);
      return(QUIT);
#endif	/* WINDOWS */
    }
  }
#endif	/* WINSOCK */

#if defined(INETBIOS) || defined(PATHWAY) || defined(LWP)
  if (gn.local_spool == OFF) {	/* ͥåȥ⡼ */
    if( find_inet() == 0 ) {
      mc_puts("BIOS󤷤Ƥޤ \n");
      exit(1);
    }
  }
#endif	/*  defined(INETBIOS) || defined(PATHWAY) || defined(LWP)*/
#endif	/* ! NO_NET */
  
  if ( gn.with_gnspool == ON )
    gn.local_spool = ON;

  if ( gn.local_spool == ON ) {
    if ( gn.with_gnspool == ON ) {
      if ( gn.process_kanji_code == gn.gnspool_kanji_code )
	make_article_tmpfile = OFF;
    } else {
      if ( gn.process_kanji_code == gn.spool_kanji_code )
	make_article_tmpfile = OFF;
    }
  }
#ifdef	MIME
  if ( (gn.mime_head & MIME_DECODE) != 0 )
    make_article_tmpfile = ON;
#endif

#ifdef	WINDOWS
  GetWindowRect(GetDesktopWindow(),&lprct);	/* desktop */
  
  GetWindowRect(hWnd,&lprcw);	/* ߤ Window */
  
  if ( (gn.columns * xsiz) > lprct.right ) {	/*  desktop 礭 */
    wwidth = (lprct.right/ xsiz) * xsiz;
    xpos = 0;
  } else {
    wwidth = gn.columns * xsiz;
    xpos = lprcw.left;
  }
  if ( (xpos + wwidth) > lprct.right )
    xpos = 0;
  
  if ( (gn.lines * ysiz) > lprct.bottom ) {	/* ⤵ desktop 礭 */
    wheight = (lprct.bottom/ ysiz) * ysiz;
    ypos = 0;
  } else {
    wheight = gn.lines * ysiz;
    ypos = lprcw.top;
  }
  if ( (ypos + wheight) > lprct.bottom )
    ypos = 0;
  
  SetWindowPos(hWnd,(HWND)NULL,xpos,ypos,wwidth,wheight,
	       SWP_NOZORDER|SWP_SHOWWINDOW);
  
  xpos = ypos = 0;
  
  free(display_buf);
  if ( (display_buf = malloc(gn.lines*gn.columns)) == NULL ) {
    memory_error();
    return(QUIT);
  }
  memset(display_buf,' ',gn.lines*gn.columns);
#endif	/* WINDOWS */
  
#if defined(MSDOS)
#if ! defined(NO_NET)
#if ! defined(WINDOWS)
  if (gn.local_spool == OFF) {	/* ͥåȥ⡼ */
    if ( prog == GN || DO_POST || DO_MAIL) {
      if ( auth(gn.usrname) != 0 )	/* 桼ǧ */
	exit(1);
    }
  }
#endif	/* ! WINDOWS */
#endif	/* ! NO_NET */
#endif	/* MSDOS */
  return(check_only);
}
/*
 * struct gn νʥѥǥեȤΣ
 */
void
init_gn_1()
{
  /* ɥᥤ */
  gn.domainname = 0;			/* ɥᥤ̾ */
  gn.organization = 0;			/* ȿ̾ */
  gn.genericfrom = DEFAULT_GENERICFROM;	/* From: ˥ۥ̾Ĥʤ */

  /* ˥塼ƥ */
  gn.nntpserver = 0;		/* ˥塼 */
  gn.spool_kanji_code = JIS;	/* NNTP δ */
  gn.mode_reader = OFF;		/* Inn ξ ON ˤ mode reader  */
  gn.nntp_auth = OFF;		/* NNTP ˤ桼ǧ */
#if defined(NO_NET)
  gn.local_spool = ON;		/* ޥΥס򸫤 */
#else
  gn.local_spool = OFF;		/* ޥΥס򸫤 */
#endif
  gn.use_history = OFF;		/* history Ѥ */
  gn.postproc = 0;		/* ݥȤݤ˻Ѥץ */
  gn.newslib = 0;		/* /usr/lib/news */
  gn.newsspool = 0;		/* /usr/spool/news */
  gn.dos_newfs = OFF;		/* HPFS,NTFS,VFAT  spool  */

  /* ᥤ륷ƥ */
  gn.smtpserver = 0;				/* SMTP  */
  gn.mail_kanji_code = DEFAULT_MAIL_KANJI_CODE;	/* ᥤδ */
  gn.mailer = 0;				/* ᥤ */

  /* ۥ */
  gn.hostname = 0;		/* ۥ̾ */
  gn.lines = DEFAULT_LINES;	/* ̹Կ */
  gn.columns = DEFAULT_COLUMNS; /* ̷ */
  gn.win_lines = -1;
  gn.win_columns = -1;

  gn.process_kanji_code = DEFAULT_PROCESS_KANJI_CODE;	/* ڡ㡢ǥδ */
  gn.file_kanji_code = DEFAULT_FILE_KANJI_CODE;		/* ե˥֤δ */
  gn.display_kanji_code = DEFAULT_DISPLAY_KANJI_CODE;	/* ̤δ */

#if ! defined(WINDOWS) && ! defined(QUICKWIN)
  gn.pager = 0;			/* ڡ */
  gn.return_after_pager = DEFAULT_RETURN_AFTER_PAGER;	/* ɽ Return ׵̵ͭ */
#endif	/* ! WINDOWS && !QUICKWIN */

  gn.win_pager_flag = 0;	/* ǽڡǻߤޤ */
  gn.editor = 0;		/* ǥ */
  gn.win_editor = 0;		/* Windows λΥǥ */
#ifdef	USE_FGETS
  gn.use_space = ON;		/* ڡɤ߿ʤ */
#else
  gn.use_space = OFF;		/* ڡɤ߿ʤ */
#endif
#ifdef	POWER_SAVE
  gn.power_save = COPY_TO_TMP;	/* ǥؤΥ */
#else
  gn.power_save = OFF;		/* ǥؤΥ */
#endif

  /* 桼 */
  gn.usrname = 0;	/* login name */
  gn.fullname = 0;	/* Full Name */
  gn.passwd = 0;	/* password. booooom! */

  /* directory / file */
  gn.rcfile = 0;		/* newsrc */
  gn.savedir = 0;		/* 򥻡֤ǥ쥯ȥ */
  gn.signature = 0;		/* signature file */
  gn.author_copy = 0;		/* author copy */
  gn.tmpdir = 0;		/* $TMPDIR */

  gn.jnames_file = 0;		/* jnames file for a user */

  /* ɤ */
  gn.gnus_format = 0;		/* GNUS format  .newsrc ɤ߹ */
  gn.ng_sort = NG_SORT_NO;	/* sort new newsgroup */
  gn.unsubscribe_groups = 0;
  gn.subscribe_groups = 0;
  gn.article_limit = ARTICLE_LIMIT;	/* ư̤ɵ¿ϡǧ */
  gn.article_leave = ARTICLE_LEAVE;	/* ΤƤ˻Ĥ */
  gn.select_limit = SELECT_LIMIT;	/* ¿ϡǧ */
  gn.disp_re = ON;	/* եλ Re: ɽ */
  gn.cls = OFF;		/* ̥ꥢ */
  gn.description = OFF;	/* ˥塼롼פɽ */
  gn.kill_control = 0;	/* ȥåɤ */
  gn.autolist = ON;	/* ƥ⡼ɤǤΥꥹɽưŪ˹Ԥʤ */
  gn.show_indent = OFF;	/* ⡼˻ɽ */
  gn.show_truncate = ON;/* ޤʤɽ */
  gn.mime_head = OFF;	/* إå MIME б */
  gn.gmt2jst = OFF;	/* Date: إå JST ɽ */

  /* post */
  gn.nsubject = OFF;	/* ܸ쥵֥Ȼ */
  gn.rn_like = OFF;	/* rn 饤ʰѥ */
  gn.cc2me = OFF;	/* ץ饤᡼ʬˤ Cc/Bcc */

  /* other */
#if defined(NO_NET)
  gn.with_gnspool = ON;		/* gnspool Ȥ߹碌ƻѤ */
#else
  gn.with_gnspool = OFF;	/* gnspool Ȥ߹碌ƻѤ */
#endif

  gn.gnspool_kanji_code = gn.spool_kanji_code;	/* gnspool 륹סδ */

  /* gnspool only */
  gn.fast_connect = OFF;	/* active ʤ */
  gn.remove_canceled = OFF;	/* 󥻥뤵줿ä */
}
/*
 * struct gn νʥѥǥեȤΣ
 */
int
init_gn_2()
{
  /* ɥᥤ̾ */
  if ( gn.domainname == 0 ) {
    if ( (gn.domainname = malloc(strlen(DEFAULT_DOMAINNAME)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.domainname,DEFAULT_DOMAINNAME);
  }

  /* ȿ̾ */
  if ( gn.organization == 0 ) {
    if ( (gn.organization = malloc(strlen(DEFAULT_ORGANIZATION)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.organization,DEFAULT_ORGANIZATION);
  }

  /* ˥塼 */
  if ( gn.nntpserver == 0 ) {
    if ( (gn.nntpserver = malloc(strlen(DEFAULT_NNTPSERVER)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.nntpserver,DEFAULT_NNTPSERVER);
  }

  /* ݥȤݤ˻Ѥץ */
  if ( gn.postproc == 0 ) {
    if ( (gn.postproc = malloc(strlen(DEFAULT_POSTPROC)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.postproc,DEFAULT_POSTPROC);
  }

  /* /usr/lib/news */
  if ( gn.newslib == 0 ) {
    if ( (gn.newslib = malloc(strlen(DEFAULT_NEWSLIB)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.newslib,DEFAULT_NEWSLIB);
  }

  /* /usr/spool/news */
  if ( gn.newsspool == 0 ) {
    if ( (gn.newsspool = malloc(strlen(DEFAULT_NEWSSPOOL)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.newsspool,DEFAULT_NEWSSPOOL);
  }

  /* smtp  */
  if ( gn.smtpserver == 0 ) {
    if ( (gn.smtpserver = malloc(strlen(DEFAULT_SMTPSERVER)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.smtpserver,DEFAULT_SMTPSERVER);
  }

  /* ᥤ */
  if ( gn.mailer == 0 ) {
    if ( (gn.mailer = malloc(strlen(DEFAULT_MAILER)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.mailer,DEFAULT_MAILER);
  }

#if ! defined(WINDOWS) && ! defined(QUICKWIN)
  /* ڡ */
  if ( gn.pager == 0 ) {
    if ( (gn.pager = malloc(strlen(DEFAULT_PAGER) + 1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.pager,DEFAULT_PAGER);
  }
#endif	/* ! WINDOWS && !QUICKWIN */

  /* ǥ */
  if ( gn.editor == 0 ) {
    if ( (gn.editor = malloc(strlen(DEFAULT_EDITOR)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.editor,DEFAULT_EDITOR);
  }

  /* newsrc */
  if ( gn.rcfile == 0 ) {
    if ( (gn.rcfile = malloc(strlen(DEFAULT_NEWSRC)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.rcfile,DEFAULT_NEWSRC);
  }

  /* 򥻡֤ǥ쥯ȥ */
  if ( gn.savedir == 0 ) {
    if ( (gn.savedir = malloc(strlen(DEFAULT_SAVEDIR)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.savedir,DEFAULT_SAVEDIR);
  }

  /* signature file */
  if ( gn.signature == 0 ) {
    if ( (gn.signature = malloc(strlen(DEFAULT_SIGNATURE)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.signature,DEFAULT_SIGNATURE);
  }

  /* author copy */
  if ( gn.author_copy == 0 ) {
    if ( (gn.author_copy = malloc(strlen(DEFAULT_AUTHORCOPY)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.author_copy,DEFAULT_AUTHORCOPY);
  }

  /* $TMPDIR */
  if ( gn.tmpdir == 0 ) {
    if ( (gn.tmpdir = malloc(strlen(DEFAULT_TMPDIR)+1)) == NULL ) {
      memory_error();
      return(QUIT);
    }
    strcpy(gn.tmpdir,DEFAULT_TMPDIR);
  }

  return(CONT);
}
#ifdef	SIGWINCH
static void
resize_window()
{
  struct winsize buf;
  
  if (ioctl (0, TIOCGWINSZ, &buf) < 0)
    return;
  
  if ( gn.lines == buf.ws_row && gn.columns == buf.ws_col )
    return;
  
  if ( buf.ws_row != 0 )
    gn.lines = buf.ws_row;
  if ( buf.ws_col != 0 )
    gn.columns = buf.ws_col;
  
  if ( redraw_func != (void (*)())NULL)
    redraw_func();
  
  signal(SIGWINCH, resize_window);
}
#endif

#ifdef	SIGCONT
static void
foreground()
{
  if ( redraw_func != (void (*)())NULL)
    redraw_func();
  
  signal(SIGCONT, foreground);
}
#endif

/*
 * gnrc ɤ߹
 */
int
read_gnrc(gnrc)
register char *gnrc;	/* gnrc Υѥ̾ */
{
  register char *pt;
  FILE *fp;
  struct stat stat_buf;
  char resp[NNTP_STRLEN*2+1];
  char buf[NNTP_STRLEN*2+1];
  register struct env_t *env_tp;
  register struct gnrc_t *gnrc_tp;
  char gnrc_tmp[PATH_LEN+1];
  
  if ( stat(gnrc,&stat_buf) != 0 )
    return(CONT);
  
  if ( (fp = fopen(gnrc,"r")) == NULL )
    return(CONT);
  
  if ( strncmp(gnrc,gn.home,strlen(gn.home)) == 0 ) {
    strcpy(gnrc_tmp,"~/");
    strcat(gnrc_tmp,&gnrc[strlen(gn.home)+1]);
  } else {
    strcpy(gnrc_tmp,gnrc);
  }
  mc_printf("reading %s\n",gnrc_tmp,0,0,0);
  
  while ( fgets(resp,NNTP_STRLEN*2,fp) != NULL ) {
    if ( (pt = strchr(resp,'\n')) !=NULL )
      *pt = 0;
    pt = &resp[0];
    while ( *pt == ' ' || *pt == '\t' )
      pt++;			/* Ԥۥ磻ȥڡ̵ */
    if ( *pt == 0 )
      continue;			/* ۥ磻ȥڡΤ */
    if ( *pt == '#' )
      continue;
    while ( *pt != 0 && *pt != ' ' && *pt != '\t' )
      pt++;
    if ( *pt == 0 ) {		/* value ʤ */
      mc_printf("%s ʹԤޤ:%s",gnrc_tmp,resp);
      continue;
    }
    *pt++ = 0;
    while ( *pt == ' ' || *pt == '\t' )
      pt++;			/* keyword  value δ֤Υۥ磻ȥڡ */
    if ( *pt == 0 ) {		/* value ʤ */
      mc_printf("%s ʹԤޤ:%s",gnrc_tmp,resp);
      continue;
    }

    /* Ķѿȶ̤:ʸ */
    for ( env_tp = &env_table[0] ; env_tp->str != 0 ; env_tp++ ) {
      if (strcmp(env_tp->str,resp) == 0 ) {
	if ( *(env_tp->value) != 0 )
	  free(*(env_tp->value));
	kanji_convert(gn.file_kanji_code,pt,internal_kanji_code,buf);
	if ( (*(env_tp->value) = malloc(strlen(buf)+1)) == NULL ) {
	  memory_error();
	  return(ERROR);
	}
	strcpy(*(env_tp->value),buf);
	break;
      }
    }
    if ( env_tp->str != 0 )
      continue;

    /* gnrc ͭ: */
    for ( gnrc_tp = &gnrc_table[0] ; gnrc_tp->str != 0 ; gnrc_tp++ ) {
      if (strcmp(gnrc_tp->str,resp) == 0 ) {
	if ( '0' <= *pt && *pt <= '9' ) {
	  *(gnrc_tp->value) = atoi(pt);
	  break;
	}
	if ( strcmp(pt, "ON") == 0 || strcmp(pt, "YES") == 0 ) {
	  *(gnrc_tp->value) = ON;
	  break;
	}
	if ( strcmp(pt, "OFF") == 0 || strcmp(pt, "NO") == 0 ) {
	  *(gnrc_tp->value) = OFF;
	  break;
	}
	mc_printf("%s  %s ˤϿꤷƲ\n",gnrc_tmp,resp);
	break;
      }
    }
    if ( gnrc_tp->str != 0 )
      continue;

    mc_printf("%s ʥɤޤ:%s\n",gnrc_tmp,resp);
  }
  
  fclose(fp);
  return(CONT);
}

/*
 * Ķѿβ
 */
int
read_env()
{
  register struct env_t *env_tp;
  register struct gnrc_t *gnrc_tp;
  register char *env;
  
  /* gnrc ȶ̤:ʸ */
  for ( env_tp = &env_table[0] ; env_tp->str != 0 ; env_tp++ ) {
    if ((env = getenv(env_tp->str)) == 0)
      continue;

    if ( *(env_tp->value) != 0 )
      free(*(env_tp->value));
    if ( (*(env_tp->value) = malloc(strlen(env)+1)) == NULL ) {
      memory_error();
      return(ERROR);
    }
    strcpy(*(env_tp->value),env);
  }
  
  /* gnrc ͭ: */
  for ( gnrc_tp = &gnrc_table[0] ; gnrc_tp->str != 0 ; gnrc_tp++ ) {
    if ((env = getenv(gnrc_tp->str)) == 0)
      continue;

    if ( '0' <= *env && *env <= '9' ) {
      *(gnrc_tp->value) = atoi(env);
      continue;
    }
    if ( strcmp(env, "ON") == 0 || strcmp(env, "YES") == 0 ) {
      *(gnrc_tp->value) = ON;
      continue;
    }
    if ( strcmp(env, "OFF") == 0 || strcmp(env, "NO") == 0 ) {
      *(gnrc_tp->value) = OFF;
      continue;
    }
    mc_printf("Ķѿ %s ˤϿꤷƲ\n",gnrc_tp->str);
  }
  
  return(CONT);
}




/*
 * ɽɤ롼פβ
 */
int
check_regexp_group(ig_string,ig)
register char *ig_string;
register regexp_group_t **ig;
{
  extern int check_reg();
  
  register char *pt,ch;
  
  if ( (pt = strchr(ig_string,'\n')) != NULL )
    *pt = 0;
  if ( (pt = strchr(ig_string,'\r')) != NULL )
    *pt = 0;
  
  for ( pt = ig_string; ; ig = &((*ig)->next)) {

    while( *pt == ' ' || *pt == '\t' )
      pt++;
    if ( *pt == 0 )
      break;

    if ( (*ig = (regexp_group_t *)malloc(sizeof(regexp_group_t))) == NULL ) {
      memory_error();
      return(ERROR);
    }

    (*ig)->flag = YES;
    if ( *pt == '!' ) {
      (*ig)->flag = NO;
      pt++;
    }
    (*ig)->name = pt;
    (*ig)->next = 0;

    while ( *pt != 0 && *pt != ',' && *pt != ' ' && *pt != '\t' )
      pt++;
    ch = *pt;
    *pt++ = 0;
    (*ig)->len = strlen((*ig)->name);

    if ( (*ig)->len == 0 ) {
      mc_printf("! ϡ̵뤷ޤ\n",(*ig)->name);
      continue;
    }
    /* ɽΥå */
    if ( check_reg(*ig) == ERROR ){
      (*ig)->len = 0;
      mc_printf("%s ϡ̵뤷ޤ\n",(*ig)->name);
      continue;
    }
    if ( ch == 0 )
      break;

    while ( *pt == ',' || *pt == ' ' || *pt == '\t' )
      *pt++ = 0;
  }
  return(CONT);
}

/* ɽΥå */
int
check_reg(ig)
regexp_group_t *ig;
{
  char *pt;
  char ch;

  /* [] ˤɽ */
  for ( pt = ig->name; *pt != 0; pt++ ) {
    if ( (pt = strchr(pt,'[')) == NULL ) /* ʾ [ ʤ */
      break;

    ig->len = -1;		/* ɽͭ */

    if ( strchr(pt,']') == NULL )
      return(ERROR);		/* ] ĤƤʤ */

    pt++;
    if ( *pt == ']' )
      return(ERROR);		/* [] ϥ顼 */

    while ( *pt != ']' ) {
      if ( *pt == '[' )
	return(ERROR);		/* Ĥ [ 褿 */

      if ( pt[1] == '-' ) {
	if ( strchr(&pt[3],']') == NULL )
	  return(ERROR);	/* ĤƤʤ */
	if ( pt[0] > pt[2] )
	  return(ERROR);	/* Ǥʤ */
	pt += 3;
      } else {
	pt++;
      }
    }
    pt++;
  }

  /* all */
  ch = '.';
  for ( pt = ig->name; *pt != 0; ch = *pt++ ) {
    if ( ch != '.' )
      continue;
    if ( strlen(pt) < 3 )
      break;
    if ( *pt != 'a' )
      continue;
    if ( strncmp(pt,"all",3) != 0 )
      continue;

    if ( pt[3] == 0 || pt[3] == '.' ) {
      ig->len = -1;		/* ɽͭ */
      break;
    }
    pt += 3;
  }
  return(CONT);
}


#ifdef DOSFS

#if defined( OS2 )
GetDisk()
{
  USHORT DriveNumber;
  ULONG LogicalDriveMap;
  USHORT rc;
  
  rc = DosQCurDisk(&DriveNumber, &LogicalDriveMap);
  return (int)DriveNumber-1;
}

SetDisk(disk)
int disk;
{
  USHORT DriveNumber = disk+1;
  USHORT rc;
  
  if (disk == GetDisk()) return 0;
  
  rc = DosSelectDisk(DriveNumber);
  
  return (int)rc;
}

static VIOMODEINFO *GetScreenInfo()
{
  static VIOMODEINFO ModeData;
  static int initialized = 0;
  
  if (!initialized)
    {
      initialized = 1;

      ModeData.cb = sizeof(ModeData);
      VioGetMode(&ModeData, 0);
    }
  return &ModeData;
}

GetLines()
{
  return GetScreenInfo()->row;
}

GetColumns()
{
  return GetScreenInfo()->col;
}
#else 	/* OS2 */
#if defined (HUMAN68K)
#include <unistd.h>
GetDisk()
{
  return (getdrive() - 1);
}

SetDisk(disk)
int disk;
{
  int ordisk;
  if (disk == (ordisk=GetDisk())) return 0;
  
  chdrive(disk + 1);
  if (ordisk == GetDisk()) return 1;	/* Can't change disk drive */
  return 0;
}
#else	/* HUMAN68K */
#if defined(MSC)
GetDisk()
{
  return(_getdrive() -1);
}

SetDisk(disk)
int disk;
{
  if ( _chdrive(disk+1) == 0 )
    return(0);
  return(1);		/* Can't change disk drive */
}
#else	/* MSC */
#include <dos.h>
GetDisk()
{
  union REGS reg;

  reg.h.ah = 0x19;
  return(intdos(&reg, &reg) & 0x00ff);
}

SetDisk(disk)
int disk;
{
  union REGS reg;
  int ordisk;
  
  if (disk == (ordisk=GetDisk())) return 0;
  
  reg.h.ah = 0x0e;
  reg.h.dl = disk;
  intdos(&reg, &reg);
  if (ordisk == GetDisk()) return 1;	/* Can't change disk drive */
  return 0;
}
#endif	/* MSC */

#if defined(DOSV) && !defined(GNUDOS)
GetLines()
{
  return (int) (*(unsigned char *)0x00400084) + 1;
}

GetColumns()
{
  return *(unsigned short *)0x0040004a;
}
#endif	/* DOSV && !GNUDOS */

#endif	/* HUMAN68K */
#endif	/* OS2 */
#endif	/* MSDOS */
