/*
 * @(#)smtp.c	1.34 Nov.21,1995
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * Copyright (C) yamasita@omronsoft.co.jp
 */

/*
 * This software is Copyright 1991 by Stan Barber. 
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction or this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * The author make no claims as to the fitness or correctness of this software
 * for any use whatsoever, and it is provided as is. Any use of this software
 * is at the user's own risk. 
 *
 */

#ifdef WINDOWS
#	include <windows.h>
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>

#if defined(MSDOS)
#	include	<string.h>
#	include	<stdlib.h>
#	include	<io.h>
#	if ! defined(HUMAN68K) && ! defined(GNUDOS) && ! defined(__TURBOC__)
#		include	<direct.h>
#	endif
#	ifdef __TURBOC__
#		include <dir.h>
#	endif
#	if defined(WATTCP)
#			include <tcp.h>
#	endif
#	ifdef PCNFS
#		include "pcnfs.h"
#	endif
#endif /* MSDOS */

#ifdef	UNIX
#	ifdef	HAS_STRING_H
#		include	<string.h>
#	endif
#	ifdef	HAS_STDLIB_H
#		include	<stdlib.h>
#	endif
#endif /* UNIX */

#include	"nntp.h"
#include	"gn.h"

extern void mc_puts(),mc_printf();
extern void kanji_convert();
extern void hit_return();
extern int get_1_header_file();

#if defined(WINDOWS)
extern int mc_MessageBox();
extern void set_hourglass(),reset_cursor();
#endif	/* WINDOWS */

#ifdef	MIME
extern void MIME_strHeaderEncode();
#endif

static int mail_file_with_gnspool();
#if ! defined(NO_NET)
static int smtp_server_init(),smtp_get_server();
static int smtp_put_server();
extern void smtp_close_server();
static int mail_file_by_smtp(),mail_file_by_mailer();
static int smtp_get_resp();

#if defined(WATTCP)
static socket_t	sser_rd_fp;
#	define	sser_wr_fp sser_rd_fp
#else	/* WATTCP */
static socket_t	sser_rd_fp = 0;
static socket_t	sser_wr_fp = 0;
#endif	/* WATTCP */

/*
 * smtp_server_init  Get a connection to the remote smtp server.
 *
 *	Parameters:	"machine" is the machine to connect to.
 *
 *	Returns:	-1 on error
 *			0 on success.
 *
 *	Side effects:	Connects to server.
 *			"sser_rd_fp" and "sser_wr_fp" are fp's
 *			for reading and writing to server.
 */

static int
smtp_server_init(machine,resp)
char *machine;
char *resp;
{
  extern int server_init_com();
  
  return(server_init_com(machine, &sser_rd_fp, &sser_wr_fp,
			 "smtp", "tcp", resp));
}


/*
 * smtp_put_server -- send a line of text to the server, terminating it
 * with CR and LF, as per ARPA standard.
 *
 *	Parameters:	"string" is the string to be sent to the
 *			server.
 *
 *	Returns:	Nothing.
 *
 *	Side effects:	Talks to the server.
 *
 *	Note:		This routine flushes the buffer each time
 *			it is called.  For large transmissions
 *			(i.e., posting news) don't use it.  Instead,
 *			do the fprintf's yourself, and then a final
 *			fflush.
 */

static int
smtp_put_server(string)
char *string;
{
  extern int put_server_com();
  
  int	ret;
#ifdef	WINDOWS
  char buf[128];
#endif	/* WINDOWS */
  
  if ( (ret = put_server_com(string,&sser_wr_fp)) == CONT )
    return(CONT);
  
#ifdef	WINDOWS
  reset_cursor();
  
  sprintf(buf,"SMTP ФȤ³ڤޤ:%d",ret);
  mc_MessageBox(hWnd,buf,"",MB_OK);
#else	/* WINDOWS */
  mc_printf("SMTP ФȤ³ڤޤ:%d\n",ret);
#endif	/* WINDOWS */
  return(ERROR);
}

/*
 * smtp_get_server -- get a line of text from the server.  Strips
 * CR's and LF's.
 *
 *	Parameters:	"string" has the buffer space for the
 *			line received.
 *			"size" is the size of the buffer.
 *
 *	Returns:	-1 on error, 0 otherwise.
 *
 *	Side effects:	Talks to server, changes contents of "string".
 */

static int
smtp_get_server(string)
char *string;
{
  extern int get_server_com();
  
  return(get_server_com(string, NNTP_STRLEN*2, &sser_rd_fp));
}


/*
 * smtp_close_server -- close the connection to the server, after sending
 *		the "quit" command.
 *
 *	Parameters:	None.
 *
 *	Returns:	Nothing.
 *
 *	Side effects:	Closes the connection with the server.
 *			You can't use "put_server" or "get_server"
 *			after this routine is called.
 */

void
smtp_close_server()
{
  extern void close_server_com();
  
  close_server_com(&sser_rd_fp,&sser_wr_fp);
}
#endif	/* ! NO_NET */

/*
 * եᥤȤ
 */
int
mail_file(tmp_file_f)
char *tmp_file_f;	/* ե̾ */
{
  int retcode;
  
#ifdef	WINDOWS
  set_hourglass();
#endif	/* WINDOWS */
  
  if ( gn.with_gnspool ) {
    retcode = mail_file_with_gnspool(tmp_file_f);
#ifdef	WINDOWS
    reset_cursor();
#endif /* WINDOWS */
    return(retcode);
  }
  
#if ! defined(NO_NET)
#ifdef	MSDOS
  retcode = mail_file_by_smtp(tmp_file_f);
#ifdef	WINDOWS
  reset_cursor();
#endif	/* WINDOWS */
  return(retcode);
#else
  if ( strcmp(gn.mailer,"SMTP") == 0 )
    return(mail_file_by_smtp(tmp_file_f));
  else
    return(mail_file_by_mailer(tmp_file_f));
#endif	/* MSDOS */
#endif	/* NO_NET */
}
static int
mail_file_with_gnspool(tmp_file_f)
char *tmp_file_f;	/* ե̾ */
{
  char resp[NNTP_STRLEN*2+1];
  char buf[NNTP_STRLEN*2+1];
  FILE *fp,*rp;
  struct stat stat_buf;
  
  strcpy(buf,gn.newsspool);
  strcat(buf,SLASH_STR);
  strcat(buf,"mail.out");
  if ( stat(buf,&stat_buf) != 0 ) {
    if ( MKDIR(buf) != 0 ) {
      mc_printf("%s κ˼Ԥޤ\n",buf);
      return(-1);
    }
  }
  strcat(buf,SLASH_STR);
  strcat(buf,"gnXXXXXX");
  mktemp(&buf[0]);
  if ( ( rp = fopen(buf,"w") ) == NULL ){
#ifdef	WINDOWS
    mc_MessageBox(hWnd,"ƥݥեΥץ˼Ԥޤ",
		  buf,MB_OK);
#else  /* WINDOWS */
    perror(buf);
#endif /* WINDOWS */
    return(-1);
  }
  fp = fopen(tmp_file_f,"r");
  while (fgets(resp,NNTP_STRLEN*2,fp) != NULL )
    fprintf(rp, "%s", resp);
  fclose(rp);
  fclose(fp);
  return(0);
}

#if ! defined(NO_NET)
static int
mail_file_by_smtp(tmp_file_f)
char *tmp_file_f;	/* ե̾ */
{
  extern int smtp_server_init();
  extern int smtp_get_server();
  extern void smtp_close_server();
  extern int smtp_get_resp();
  
  FILE *fp;
  char resp[NNTP_STRLEN*2+1];
  char resp2[NNTP_STRLEN*2+1];
  char to[NNTP_STRLEN*2+1];
  register char *sp,*pt,*np;

#if 0
  /* To: õ */
  fp = fopen(tmp_file_f,"r");
  while (fgets(resp,NNTP_STRLEN*2,fp) != NULL ) {
    if (resp[0] == '\n' )
      break;
    if ( strncmp(resp,"To: ",4) != 0 )
      continue;

    if ( (pt = strchr(resp,'<')) != NULL ) { /* <>  */
      strcpy(to,pt+1);
      if ( (pt = strchr(to,'>')) == NULL ){
#if ! defined(WINDOWS)
	mc_puts("\n褬ǤϤޤ \n\007");
	hit_return();
#else  /* WINDOWS */
	mc_MessageBox(hWnd," 褬ǤϤޤ ","mail",MB_OK);
#endif /* WINDOWS */
	return(ERROR);
      }
      *pt = 0;
      break;
    }
    pt = &resp[4];
    while ( *pt == ' ' || *pt == '\t' )
      pt++;
    strcpy(to,pt);
    if ( (pt = strchr(to,'(')) != NULL )
      *pt = 0;
    pt = &to[strlen(to)-1];
    while ( *pt == ' ' || *pt == '\t' )
      *pt-- = 0;
  }
  fclose(fp);

  if ( (pt = strchr(to,'\n')) != NULL )
    *pt = 0;
#endif

  /* SMTP Фν */
  if ( prog == GN || (prog == GNSPOOL && init_smtp_server == NO) ) {
    init_smtp_server = YES;
#if ! defined(WINDOWS)
    mc_puts("smtp Ф³Ƥޤ\n");
#endif /* WINDOWS */
    
    if ( smtp_server_init(gn.smtpserver,resp) != 220 ) {
#if ! defined(WINDOWS)
      mc_puts("smtp Ф³ǤޤǤ\n");
      hit_return();
#else  /* WINDOWS */
      mc_MessageBox(hWnd," smtp Ф³ǤޤǤ ","mail",MB_OK);
#endif /* WINDOWS */
      return(ERROR);
    }
    if  ( resp[3] == '-' ) {
      if ( smtp_get_resp(220) )
	return(ERROR);
    }
  }  
  sprintf(resp,"helo %s",gn.hostname);
  if ( smtp_put_server(resp) != CONT )
    return(ERROR);
  if ( smtp_get_resp(250) )
    return(ERROR);
  
  sprintf( resp, "mail from: <%s>", gn.usrname);
  if ( smtp_put_server( resp ) != CONT )
    return(ERROR);
  if ( smtp_get_resp(250) )
    return(ERROR);



  /* õ */
  fp = fopen(tmp_file_f,"r");

  resp[0] = 0;
  get_1_header_file(resp2,resp,fp);
  while (1) {
    get_1_header_file(resp2,resp,fp);
    if (resp2[0] == 0 )
      break;

    if (strncmp(resp2,"To: ",4) != 0 && strncmp(resp2,"to: ",4) != 0 && 
	strncmp(resp2,"Cc: ",4) != 0 && strncmp(resp2,"cc: ",4) != 0 && 
	strncmp(resp2,"Bcc: ",5) != 0 && strncmp(resp2,"bcc: ",5) != 0 ) {
      continue;
    }

    np = strchr(resp2,' ');
    np++;
    while ( *np != 0 ) {
      pt = np;
      while (*pt == ' ' || *pt == '\t' || *pt == ',' || *pt == '\n' )
	pt++;

      /* Ĥ */
      for ( np = pt; *np != ',' && *np != '\n' && *np != 0 ; np++)
	;
      if ( *np == 0 )
	np[1] = 0;
      *np++ = 0;

      /*  To: Yasunari Gon Yamasita <yamasita@omronsoft.co.jp> */
      if ( (sp = strchr(pt,'<')) != NULL ) {
	pt = &sp[1];
	if ( (sp = strchr(pt,'>')) == NULL ){ 	/* > ĤƤʤ */
#if ! defined(WINDOWS)
	  mc_puts("\n%s: 褬ǤϤޤ \n\007",pt);
	  hit_return();
#else  /* WINDOWS */
	  mc_MessageBox(hWnd," 褬ǤϤޤ ","mail",MB_OK);
#endif /* WINDOWS */
	  return(ERROR);
	}
	*sp = 0;

	if (strchr(pt,' ') != NULL ||
	    strchr(pt,' ') != NULL ) { /* <> ˥ۥ磻ȥڡ */
#if ! defined(WINDOWS)
	  mc_puts("\n%s: 褬ǤϤޤ \n\007",pt);
	  hit_return();
#else  /* WINDOWS */
	  mc_MessageBox(hWnd," 褬ǤϤޤ ","mail",MB_OK);
#endif /* WINDOWS */
	  return(ERROR);
	}
	sprintf( to, "rcpt to: <%s>", pt);
	if ( smtp_put_server( to ) != CONT )
	  return(ERROR);
	if ( smtp_get_resp(250) )
	  return(ERROR);
	continue;
      }

      /* To: yamasita@omronsoft.co.jp (Yasunari Gon Yamasita) */
      if ( (sp = strchr(pt,' ')) != NULL )
	*sp = 0;
      if ( (sp = strchr(pt,'\t')) != NULL )
	*sp = 0;

      sprintf( to, "rcpt to: <%s>", pt);
      if ( smtp_put_server( to ) != CONT )
	return(ERROR);
      if ( smtp_get_resp(250) )
	return(ERROR);
    }
  }
  fclose(fp);

#if 0  
  sprintf( resp, "rcpt to: <%s>", to);
  if ( smtp_put_server( resp ) != CONT )
    return(ERROR);
  if ( smtp_get_resp(250) )
    return(ERROR);
#endif

  if ( smtp_put_server("data") != CONT )
    return(ERROR);
  if ( smtp_get_resp(354) )
    return(ERROR);
  
  /* إåʬ */
  if ( gn.genericfrom != 0 ) {
    sprintf(resp, "From: %s@%s (%s)", gn.usrname, gn.domainname, gn.fullname);
  } else {
    sprintf(resp, "From: %s@%s.%s (%s)",
	    gn.usrname, gn.hostname, gn.domainname, gn.fullname);
  }
  if ( smtp_put_server( resp ) != CONT )
    return(ERROR);
  
  fp = fopen(tmp_file_f,"r");
  while (fgets(resp,NNTP_STRLEN*2,fp) != NULL ) {
    if (resp[0] == '\n' )
      break;
    if ( strncmp("From: ",resp,6) == 0 )
      continue;
    if ( (sp = strchr(resp,'\n')) != NULL )
      *sp = 0;
#ifdef	MIME
    if ( (gn.mime_head & MIME_ENCODE) != 0 ) {
      kanji_convert(gn.process_kanji_code,resp,JIS,resp2);
      MIME_strHeaderEncode(resp2,resp,sizeof(resp));
    }
#endif
    if ( gn.process_kanji_code == gn.mail_kanji_code ) {
      if ( smtp_put_server( resp ) != CONT ) {
	fclose(fp);
	return(ERROR);
      }
    } else {
      kanji_tomail(resp,resp2);
      if ( smtp_put_server( resp2 ) != CONT )  {
	fclose(fp);
	return(ERROR);
      }
    }
  }
#ifdef	MIME
  if ( gn.mime_head ) {
    if ( smtp_put_server("Mime-Version: 1.0") != CONT ) {
      fclose(fp);
      return(ERROR);
    }
    if ( smtp_put_server("Content-Type: text/plain; charset=ISO-2022-JP") != CONT )  {
      fclose(fp);
      return(ERROR);
    }
  }
#endif
  
  /* إåʸδ֤ζ */
  if ( smtp_put_server( "" ) != CONT ) {
    fclose(fp);
    return(ERROR);
  }
  
  /* ʸ */
  while (fgets(resp,NNTP_STRLEN*2,fp) != NULL ) {
    if ( (sp = strchr(resp,'\n')) != NULL )
      *sp = 0;

    if ( gn.process_kanji_code == gn.mail_kanji_code ) {
      if ( smtp_put_server( resp ) != CONT ) {
	fclose(fp);
	return(ERROR);
      }
    } else {
      kanji_tomail(resp,resp2);
      if ( smtp_put_server( resp2 ) != CONT ) {
	fclose(fp);
	return(ERROR);
      }
    }
  }
  
  fclose(fp);
  if ( smtp_put_server( "." ) != CONT )
    return(ERROR);
  
  if ( smtp_get_resp(250) )
    return(ERROR);

  if ( prog != GNSPOOL )
    smtp_close_server();
  return(CONT);
}
#ifndef MSDOS
static int
mail_file_by_mailer(tmp_file_f)
char *tmp_file_f;	/* ե̾ */
{
  FILE *fp,*rp;
  char resp[NNTP_STRLEN*2+1];
  char resp2[NNTP_STRLEN*2+1];
  char buf[NNTP_STRLEN*2+1];
  int x = 0;
  
  /* ե */
  if ( ( fp = fopen(tmp_file_f,"r") ) == NULL ){
    perror(tmp_file_f);
    hit_return();
    return(ERROR);
  }
  
  if ( ( rp = popen(gn.mailer,"w") ) == NULL ) {
    perror(gn.mailer);
    hit_return();
    return(ERROR);
  }
  
  /* إå */
  resp[0] = 0;
  get_1_header_file(buf,resp,fp);
  
  while (1) {
    if ( ++x > 20 ){
      mc_printf(".");
      fflush(stdout);
      x = 0;
    }
    if (resp[0] == 0 )
      break;
    get_1_header_file(buf,resp,fp);
    if (buf[0] == 0 )
      break;

#ifdef	MIME
    if ( (gn.mime_head & MIME_ENCODE) != 0 ) {
      kanji_convert(gn.process_kanji_code,buf,JIS,resp2);
      MIME_strHeaderEncode(resp2,buf,sizeof(buf));
    }
#endif
    if ( gn.process_kanji_code == gn.mail_kanji_code ) {
      fprintf(rp, "%s\n", buf);
    } else {
      kanji_tomail(buf,resp2);
      fprintf(rp, "%s\n", resp2);
    }
  }
#ifdef	MIME
  if ( gn.mime_head ) {
    fprintf(rp,"Mime-Version: 1.0\n");
    fprintf(rp,"Content-Type: text/plain; charset=ISO-2022-JP\n");
  }
#endif
  
  /* إåʸδ֤ζ */
  fprintf(rp,"\n");
  
  /* ʸ */
  while (fgets(resp,NNTP_STRLEN*2,fp) != NULL ) {
    if ( ++x > 20 ){
      mc_printf(".");
      fflush(stdout);
      x = 0;
    }
    if ( gn.process_kanji_code == gn.mail_kanji_code ) {
      fprintf(rp, "%s", resp);
    } else {
      kanji_tomail(resp,resp2);
      fprintf(rp, "%s", resp2);
    }
  }
  
  pclose(rp);
  fclose(fp);
  return(CONT);
}
#endif	/* ! MSDOS */
#endif	/* ! NO_NET */
#if ! defined(NO_NET)
static int
smtp_get_resp(want)
int	want;	/* ɬפʥ쥹ݥ */
{
  char resp[NNTP_STRLEN*2+1];
  register char *pt;
  
  while (1) {
    if ( smtp_get_server(resp) != 0 ) {
#if ! defined(WINDOWS)
      mc_printf("\nץ饤Ǥޤ \n\007 %s\n",resp);
      hit_return();
#else  /* WINDOWS */
      mc_MessageBox(hWnd,resp,
		    "ץ饤Ǥޤ ",MB_OK);
#endif /* WINDOWS */
      smtp_close_server();
      return(ERROR);
    }

    if ( resp[0] <'0' || '9' < resp[0] )
      continue;

    if ( atoi(resp) != want ) {
#if ! defined(WINDOWS)
      mc_printf("\nץ饤Ǥޤ \n\007 %s\n",resp);
      hit_return();
#else  /* WINDOWS */
      mc_MessageBox(hWnd,resp,
		    "ץ饤Ǥޤ ",MB_OK);
#endif /* WINDOWS */
      smtp_close_server();
      return(ERROR);
    }

    pt = resp;			/* ƬΥơֹ򥹥å */
    while ( '0' <= *pt && *pt <= '9' )
      pt++;

    if ( *pt == ' ' )		/* - ʤ³ */
      break;
  }
  
  return(CONT);
}
#endif	/* ! NO_NET */
